/* expand.c: expand a file with holes into another
 *
 * 	this routine will expand the ramfs.img to a ram disk 
 *
 *		Mac Tseng 1/2/2001	LinuxDA
 */
 
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define ntohl(x) (x)

int
expand(char *from, char *to)
{
	int fdi;
	int fdo;
	unsigned int pos;
	unsigned int len;
	unsigned int count;
	char *buf;

	count = 0;

	if ((fdi = open(from,O_RDONLY)) < 0) {
		fprintf(stderr,"Can not open compressed file %s\n",from);
		return 0;
	}

	if ((fdo = open(to,O_WRONLY | O_CREAT | O_TRUNC, 0666)) < 0) {
		fprintf(stderr,"Can not open expanded file %s\n",to);
		close(fdi);
		return 0;
	}
  
  

	if (!(buf = malloc(2048))) {
		fprintf(stderr,"can not allocate memory\n");
		close(fdi);
		close(fdo);
		return 0;
	}

	/* Prefill */
  	read(fdi,&len,4);
  
/*** I think the ram disk needs not to be fill as ZERO *****
 *
 *	These garbage lines will slow the boot routine
 * 
 **************************************************************/
/*
	memset(buf, 0, 2048);
	while(len>0) {
		write(fdo, buf, (len > 2048) ? 2048 : len);
 		len -= 2048;
	}
 */
	lseek(fdo, 0, SEEK_SET);
  
	/* ZRLE */
	while (read(fdi,&pos,4) == 4) {
		if (read(fdi,&len,4) != 4) break;
		pos = ntohl(pos);
		len = ntohl(len);
    
		lseek(fdo,pos,SEEK_SET);
		read(fdi,buf,len);
		write(fdo,buf,len);
	}

	close(fdi);
	close(fdo);
	free(buf);
}
