#ifndef _KEYBOARD_H
#define _KEYBOARD_H

#include "sys_icons/icon-about.h"
#include "sys_icons/icon-calculator.h"
#include "sys_icons/icon-todo.h"
#include "sys_icons/icon-mine.h"
#include "sys_icons/icon-browser.h"
#include "sys_icons/icon-calibration.h"
#include "sys_icons/icon-paint.h"
#include "sys_icons/icon-memopad.h"
#include "sys_icons/icon-address.h"
#include "sys_icons/icon-hardball.h"
#include "sys_icons/icon-expense.h"
#include "sys_icons/icon-datebook.h"
#include "sys_icons/icon-clock.h"
#include "sys_icons/icon-ebook.h"

/******************** 2001-3-12**Added for new interface***************/
#include "icon-main-screen.h"

typedef struct{
	char	app_name[16];
	char	app_file[32];
	int	app_size;
	char	app_icon[128];
	int	icon_width;
	int	icon_height;	
	long	app_date;
} SYSDBSTRUCT;



static char category_index[18];
static char app_files[9][32];
static char icon_bmp_data_1[128],icon_name_1[16];
static char icon_bmp_data_2[128],icon_name_2[16];
static char icon_bmp_data_3[128],icon_name_3[16];
static char icon_bmp_data_4[128],icon_name_4[16];
static char icon_bmp_data_5[128],icon_name_5[16];
static char icon_bmp_data_6[128],icon_name_6[16];
static char icon_bmp_data_7[128],icon_name_7[16];
static char icon_bmp_data_8[128],icon_name_8[16];
static char icon_bmp_data_9[128],icon_name_9[16];

static BITMAP icon_bmp[]={{icon_about_width,icon_about_height,icon_bmp_data_1,icon_name_1},
							{icon_about_width,icon_about_height,icon_bmp_data_2,icon_name_2},
							{icon_about_width,icon_about_height,icon_bmp_data_3,icon_name_3},
							{icon_about_width,icon_about_height,icon_bmp_data_4,icon_name_4},
							{icon_about_width,icon_about_height,icon_bmp_data_5,icon_name_5},
							{icon_about_width,icon_about_height,icon_bmp_data_6,icon_name_6},
							{icon_about_width,icon_about_height,icon_bmp_data_7,icon_name_7},
							{icon_about_width,icon_about_height,icon_bmp_data_8,icon_name_8},
							{icon_about_width,icon_about_height,icon_bmp_data_9,icon_name_9}};
static BITMAP icon_back_light_bmp[]={icon_back_light_width,icon_back_light_height,icon_back_light_bitmap,NULL};
static BITMAP icon_lighter_bmp[]={icon_lighter_width,icon_lighter_height,icon_lighter_bitmap,NULL};
static BITMAP icon_darker_bmp[]={icon_darker_width,icon_darker_height,icon_darker_bitmap,NULL};

static ITEM cb_items[18];
static COMBOBOX cb_category = {5,0,70,53,cb_items};
static SCROLLBAR scr_list = {2,0,2};
static FORMCAPTION	main_caption={"LinuxDA",NULL};

#define IDD_BITMAP1	1
#define IDD_BITMAP2	2
#define IDD_BITMAP3	3
#define IDD_BITMAP4	4
#define IDD_BITMAP5	5
#define IDD_BITMAP6	6
#define IDD_BITMAP7	7
#define IDD_BITMAP8	8
#define IDD_BITMAP9	9
#define IDD_SCROLL	10
#define IDD_COMBOBOX	11
#define IDD_BACKLIGHT	12
#define IDD_DARKER	13
#define IDD_LIGHTER	14


#define IDD_CLOCK		20
#define IDD_ABOUT		21
#define IDD_CALIBRATION	22
#define IDD_PREF		23

#define ICON_Y_START	20
#define ICON_WIDTH		50
#define ICON_HEIGHT		42

static FORM FrmMain[]={
   	// the FORM of desktop
	{FORM_CAPTION,0,0,0,160,160,&main_caption,FORM_FRAME_CAPTION,COMPONENT_VISIBLE,FONT_MEDIUM},

	{FORM_MENU,0,2,0,0,0,"Option",0,0,0},
	{FORM_MENUITEM,IDD_PREF,0,0,0,0,"Preference... ",0,0,0},
	{FORM_MENUITEM,IDD_CALIBRATION,0,0,0,0,"Calibration... ",0,0,0},

	{FORM_MENU,0,50,0,0,0,"Help",0,0,0},
	{FORM_MENUITEM,IDD_ABOUT,0,0,0,0,"About Us... ",0,0,0},

	{FORM_BITMAP,IDD_CLOCK,10,150,45,9,NULL,0,COMPONENT_VISIBLE},	// the region to display current time

	{FORM_BITMAP,IDD_BACKLIGHT,110,150,10,9,icon_back_light_bmp,BITMAP_BUTTON,COMPONENT_VISIBLE},	// the region to display current time
	{FORM_BITMAP,IDD_DARKER,130,151,10,9,icon_darker_bmp,BITMAP_BUTTON,COMPONENT_VISIBLE},	// the region to display current time
	{FORM_BITMAP,IDD_LIGHTER,140,151,10,9,icon_lighter_bmp,BITMAP_BUTTON,COMPONENT_VISIBLE},	// the region to display current time

	{FORM_SCROLLBAR,IDD_SCROLL,151,20,10,126,&scr_list,VSCROLLBAR,COMPONENT_INVISIBLE},
	{FORM_COMBOBOX,IDD_COMBOBOX,90,1,70,0,&cb_category,COMBOBOX_RIGHT_ALIGN|COMBOBOX_NO_BORDER,COMPONENT_VISIBLE,FONT_SMALL},

	{FORM_BITMAP,IDD_BITMAP1,0*ICON_WIDTH,ICON_Y_START+0*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP2,1*ICON_WIDTH,ICON_Y_START+0*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP3,2*ICON_WIDTH,ICON_Y_START+0*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP4,0*ICON_WIDTH,ICON_Y_START+1*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP5,1*ICON_WIDTH,ICON_Y_START+1*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP6,2*ICON_WIDTH,ICON_Y_START+1*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP7,0*ICON_WIDTH,ICON_Y_START+2*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP8,1*ICON_WIDTH,ICON_Y_START+2*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       
	{FORM_BITMAP,IDD_BITMAP9,2*ICON_WIDTH,ICON_Y_START+2*ICON_HEIGHT,ICON_WIDTH,ICON_HEIGHT,NULL,
		BITMAP_BUTTON,COMPONENT_INVISIBLE},       

	{FORM_END},
};


#endif