#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <linux/fb.h>
#include <linux/timer.h>
#include "../../libc/include/time.h"

#include <time.h>


#include "gui.h"
#include "mini_gui.h"

/************* static functions *********/
static void wait_pref_loop(void);


#define IDD_EXIT		10
#define IDD_SETTIME		11
#define IDD_SETDATE		12
#define IDD_AUTOOFF		13
#define IDD_SYSSOUND	14
#define IDD_ALARMSOUND	15
#define IDD_GAMESOUND	16
#define IDD_BEAMRECV	17

static FORMCAPTION pref_caption={"Preferences"};
static char time_str[20]= "03:50 pm";
static BITMAP	bmp_settime={30,20,NULL,time_str};
static char date_str[20] = "01/01/01";
static BITMAP	bmp_setdate={0,0,NULL,date_str};

static ITEM items_autooff[]= {{1,"1 minute"},{2,"2 minutes"},{3,"3 minutes"},{0,"Never"}};
static COMBOBOX	combo_autooff={4,0,45,50,&items_autooff};

static ITEM items_syssound[]= {{0,"Off"},{1,"Low"},{2,"Medium"},{3,"High"}};
static COMBOBOX	combo_syssound={4,1,45,45,&items_syssound};

static ITEM items_alarmsound[]= {{0,"Off"},{1,"Low"},{2,"Medium"},{3,"High"}};
static COMBOBOX	combo_alarmsound={4,3,45,45,&items_alarmsound};

static ITEM items_gamesound[]= {{0,"Off"},{1,"Low"},{2,"Medium"},{3,"High"}};
static COMBOBOX	combo_gamesound={4,3,45,45,&items_gamesound};

static ITEM items_beamrecv[]= {{0,"Off"},{1,"On"}};
static COMBOBOX	combo_beamrecv={2,1,30,30,&items_beamrecv};

FORM frmPref[]={
	{FORM_CAPTION,0,0,0,160,160,&pref_caption,FORM_CAPTION,0,FONT_MEDIUM},
	{FORM_BUTTON,IDD_EXIT,120,0,40,12,"Exit",BUTTON_NO_BORDER,COMPONENT_VISIBLE},

	{FORM_LABEL,0,0,20,90,12,"Set Time:",X_ALIGN_RIGHT | Y_ALIGN_CENTER,COMPONENT_VISIBLE,FONT_MEDIUM},
	{FORM_LABEL,0,0,35,90,12,"Set Date:",X_ALIGN_RIGHT | Y_ALIGN_CENTER,COMPONENT_VISIBLE,FONT_MEDIUM},
	{FORM_LABEL,0,0,50,90,12,"Auto-off after:",X_ALIGN_RIGHT | Y_ALIGN_CENTER,COMPONENT_VISIBLE,FONT_MEDIUM},
	{FORM_LABEL,0,0,65,90,12,"System Sound:",X_ALIGN_RIGHT | Y_ALIGN_CENTER,COMPONENT_VISIBLE,FONT_MEDIUM},
	{FORM_LABEL,0,0,80,90,12,"Alarm Sound:",X_ALIGN_RIGHT | Y_ALIGN_CENTER,COMPONENT_VISIBLE,FONT_MEDIUM},
	{FORM_LABEL,0,0,95,90,12,"Game Sound:",X_ALIGN_RIGHT | Y_ALIGN_CENTER,COMPONENT_VISIBLE,FONT_MEDIUM},
	{FORM_LABEL,0,0,110,90,12,"Beam Receive:",X_ALIGN_RIGHT | Y_ALIGN_CENTER,COMPONENT_VISIBLE,FONT_MEDIUM},

	{FORM_BITMAP,IDD_SETTIME,95,20,40,12,&bmp_settime,BITMAP_DOTBORDER | BITMAP_BUTTON | BITMAP_CAPTION_INNER,COMPONENT_VISIBLE,0},
	{FORM_BITMAP,IDD_SETDATE,95,35,60,12,&bmp_setdate,BITMAP_DOTBORDER | BITMAP_BUTTON | BITMAP_CAPTION_INNER,COMPONENT_VISIBLE,0},
	{FORM_COMBOBOX,IDD_AUTOOFF,95,48,55,16,&combo_autooff,COMBOBOX_NO_BORDER | COMBOBOX_LEFT_ALIGN,COMPONENT_VISIBLE,0},
	{FORM_COMBOBOX,IDD_SYSSOUND,95,63,55,16,&combo_syssound,COMBOBOX_NO_BORDER | COMBOBOX_LEFT_ALIGN,COMPONENT_VISIBLE,0},
	{FORM_COMBOBOX,IDD_ALARMSOUND,95,78,55,16,&combo_alarmsound,COMBOBOX_NO_BORDER | COMBOBOX_LEFT_ALIGN,COMPONENT_VISIBLE,0},
	{FORM_COMBOBOX,IDD_GAMESOUND,95,93,55,16,&combo_gamesound,COMBOBOX_NO_BORDER | COMBOBOX_LEFT_ALIGN,COMPONENT_VISIBLE,0},
	{FORM_COMBOBOX,IDD_BEAMRECV,95,108,30,16,&combo_beamrecv,COMBOBOX_NO_BORDER | COMBOBOX_LEFT_ALIGN,COMPONENT_VISIBLE,0},


	{FORM_END}
};


void ShowPreferences(void)
{
	InitInterface();
	wait_pref_loop();
}
// initialize the time string,date string
static void InitInterface(void)
{
	time_t td;
	CreateForm(frmPref);
	
	time(&td);
	ShowBitmapTime(td);
	ShowBitmapDate(td);
}	
static void wait_pref_loop(void)
{
	U8 loopFlag=1;
	GUI_MSG msg;

	while (loopFlag) {
		msg.id = 0;
		GetMessage(frmPref,&msg);

		switch (msg.id) {
			case IDD_EXIT:
				SaveSettings();
				loopFlag = 0;
			break;
			case IDD_SETTIME:
				SetTime();
			break;
			case IDD_SETDATE:
				SetDate();
				InitInterface();
			break;
		}	/*** end of msg.id switch ***/
	}	/**** end of message loop ***/
}
// set date
static void SetDate(void)
{
	time_t td;
	struct tm *dc;
	short year,day,mon,hour,min;
	short idx;
		
	time(&td);
	dc = gmtime(&td);
	
	year = dc->tm_year;day = dc->tm_mday;mon = dc->tm_mon;
	
	//printf("hour=%d\n",dc->tm_hour);
	Showdate(&year,&mon,&day);

	//printf("hour2=%d\n",dc->tm_hour);

	dc->tm_year = year;
	dc->tm_mon = mon;
	dc->tm_mday = day;
//	dc->tm_hour = hour;
//	dc->tm_min = min;
	
	td = mktime(dc);
	stime(&td);
	
	ShowBitmapDate(td);
}
static void ShowBitmapDate(time_t td)
{	
	struct tm *dc;
	short idx;
	
	//time(&td);
	
	dc = gmtime(&td);
	strcpy(date_str,itoa(dc->tm_year+1900));
	strcat(date_str,"/");
	strcat(date_str,itoa(dc->tm_mon+1));
	strcat(date_str,"/");
	strcat(date_str,itoa(dc->tm_mday));
	//printf("day:%d\n",dc->tm_mday);

	idx = GetIndexFromId(frmPref,IDD_SETDATE);
	HideComponent(idx,frmPref);
	ShowComponent(idx,frmPref);
}

// Set the clock
static void SetTime(void)
{
	time_t td;
	
	time(&td);	// get current time 
	gui_settime(&td);	// transfer current time to the gui & get back the new time
	stime(&td);		// set system time to returned value
	ShowBitmapTime(td);	// show current time in bitmap IDD_SETTIME 
}
// display the given time in bitmap IDD_SETTIME
static void ShowBitmapTime(time_t td)
{
	char s[15];
	struct tm *dc;
	short idx;
	char *p;
	
	dc = gmtime(&td);
	
	if (dc->tm_hour<10) strcpy(s,"0");
	strcat(s,itoa(dc->tm_hour));
	
	
	strcat(s,":");
	if (dc->tm_min<10) strcat(s,"0");
	strcat(s,itoa(dc->tm_min));
	
	//printf("addr:%x,%s\n",bmp_settime.caption,bmp_settime.caption);
	strcpy(bmp_settime.caption,s);
	
	idx = GetIndexFromId(frmPref,IDD_SETTIME);
	HideComponent(idx,frmPref);
	ShowComponent(idx,frmPref);
	//RefreshComponent(idx,frmPref);
}
// Save system preferences settings
static void SaveSettings(void)
{
	short idx,i;
	COMBOBOX *cbx;
	idx = GetIndexFromId(frmPref,IDD_AUTOOFF);
	cbx = frmPref[idx].text;
	
	i = items_autooff[cbx->selected].index*60;
	SetAutoOffTime(i);
}