#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/types.h>

#include "linux/gui.h"
#include <timer.h>
#include <mathf.h>

#include "mini_gui.h"
#include "math.h"
#include <time.h>

#include "prog1.rsrc"

/* the clock's radius*/
#define RADIUS  40

/* the co-ordinate of the center of the clock*/ 
#define CENTER_X 80
#define CENTER_Y 80

/* the metres of the clocks*/
#define DIVISION 60

#define S_PIN_LEN 35.0/40
#define M_PIN_LEN 30.0/40
#define H_PIN_LEN 20.0/40

#define PI 3.141593

#define MENU_FILE 		10
#define MENUITEM_EXIT	12
#define BUTTON_SPIN		30
#define CHK_BUTTON		40
#define IDD_COMBOBOX 	41
#define IDD_SCROLLBAR	42
#define IDD_TEST		55
#define IDD_ADDITEM	90

PIXEL  div[DIVISION];
static time_t oldtime;


static SCROLLBAR scr={24,0,8};
static CHECKBUTTON	cb={0,"I am CheckButton"};
static TEXTBOX   tb={5,"",200,1,0,3};
//static TEXTBOX   tb={10,"Win it! I am a lovely guy,So that everybody likes talk to me "};

//ITEM cities[20] = {{0,"Shanghai"},{1,"Sydney"},{2,"Richmond"},{3,"London"},{4,"Beijing"},{5,"Taipei"}};
ITEM cities[20];

static COMBOBOX	 cmb={6,0,50,70,cities};
static SPINBUTTON spin={25,"ABCD"};
static FORMCAPTION frm_caption={"Clock",NULL};

unsigned char bla_str[256] = "Hi, come on,";//\n\tWe are testing \nthe multiline label";
static FORM frmClock[]={
	{FORM_CAPTION,0,0,0,160,160,&frm_caption,FORM_FRAME_CAPTION,0,0},

	{FORM_MENU,MENU_FILE,5,20,0,0,"File",0,COMPONENT_VISIBLE},
	
	{FORM_MENUITEM,MENUITEM_EXIT,5,20,0,0,"Exit",0},

	{FORM_SPINBUTTON,BUTTON_SPIN,100,130,0,0,&spin,HSPINBUTTON,COMPONENT_VISIBLE},

	{FORM_BUTTON,IDD_TEST,20,80,30,12,"Test",0,COMPONENT_VISIBLE,0},
	{FORM_BUTTON,IDD_ADDITEM,80,130,20,12,"Add",0,COMPONENT_VISIBLE},
	//{FORM_CHECKBUTTON,CHK_BUTTON,3,20,0,0,&cb,0,COMPONENT_VISIBLE},

	{FORM_COMBOBOX,IDD_COMBOBOX,95,1,62,12,&cmb,COMBOBOX_LEFT_ALIGN,COMPONENT_VISIBLE,FONT_MEDIUM},

	{FORM_TEXTBOX,50,10,25,110,12,&tb,0,COMPONENT_VISIBLE},
	{FORM_LABEL,300,2,70,50,10,&bla_str,LABEL_MULTILINE,COMPONENT_VISIBLE,FONT_SMALL},
	
	{FORM_SCROLLBAR,IDD_SCROLLBAR,150,15,30,140,&scr,VSCROLLBAR,COMPONENT_VISIBLE},

	{FORM_END},
};

static FORM frmTest[]={
	{FORM_CAPTION,0,0,80,160,80,&frm_caption,FORM_FRAME_CAPTION | FORM_FRAME_BORDER|FORM_DLGFRAME},

	{FORM_SPINBUTTON,BUTTON_SPIN,100,30,0,0,&spin,HSPINBUTTON,COMPONENT_VISIBLE},

	{FORM_BITMAP,81,40,30,10,10,NULL,BITMAP_BUTTON|BITMAP_BORDER,COMPONENT_VISIBLE},

	{FORM_CHECKBUTTON,CHK_BUTTON,3,20,0,0,&cb,0,COMPONENT_VISIBLE},

	{FORM_COMBOBOX,IDD_COMBOBOX,95,60,62,12,&cmb,COMBOBOX_LEFT_ALIGN,COMPONENT_VISIBLE,FONT_SMALL},

	{FORM_TEXTBOX,50,30,45,110,12,&tb,0,COMPONENT_VISIBLE},

	{FORM_BUTTON,IDD_TEST,30,60,25,12,"Exit",0,COMPONENT_VISIBLE},

	{FORM_SCROLLBAR,IDD_SCROLLBAR,150,15,30,40,&scr,VSCROLLBAR,COMPONENT_VISIBLE},

	{FORM_END},
};

void TestForm(void)
{
	GUI_MSG msg;
	U8 loop = 1;
	short idx;
	CHECKBUTTON *chk;

	CreateForm(frmTest);
	msg.event = EVENT_NOTHING;
	while (loop) {
		GetMessage(frmTest,&msg);
		if (msg.event == EVENT_CLICK) {
			switch (msg.id) {
				case IDD_TEST:
					loop = 0;
				break;
				case CHK_BUTTON:
					
					idx = GetIndexFromId(frmTest,CHK_BUTTON);
					chk = frmTest[idx].text;
					printf("test-");
					SendKeyToForm(frmTest,'a');
					printf("%d\n",'A');
/*					
					if (chk->value == 1) {
						HideComponent(1,frmTest);
						HideComponent(2,frmTest);
						HideComponent(4,frmTest);
						HideComponent(5,frmTest);
						HideComponent(6,frmTest);
						HideComponent(7,frmTest);
					}
					else {
						ShowComponent(1,frmTest);
						ShowComponent(2,frmTest);
						ShowComponent(4,frmTest);
						ShowComponent(5,frmTest);
						ShowComponent(6,frmTest);
						ShowComponent(7,frmTest);
					}
*/
				break;
			}
		}	// end of if EVENT
	}

	CloseForm(frmTest);
	CreateForm(frmClock);
}
ITEM itemCurr[50];
COMBOBOX comboCurrSRC={50,0,30,80,itemCurr};

void main(int argc,char *argv[])
{
	char s[64];
	short launch_cmd;
			
	init_screen();

	launch_cmd = GetLaunchCommand(argc,argv);
	
	switch (launch_cmd)
	{
		case CMD_RUN_NORMAL:
			ShowClock();
		break;
		case CMD_RUN_GET_INFO:
			PutAppInfo(&app_info);
		break;
	}   
	close_screen();
}
void ShowClock(void)
{
	
	ClearMessageQueue();
	CreateForm(frmClock);



	//draw_clock();


	wait_loop();
}		




/*initialize the clock division,and draw the clock*/
static void draw_clock(void)
{
	int i;
	float ftmp=0;
  
	for (i=0;i<60;i++)
	{
	
		div[i].x=(U16)(CENTER_X+RADIUS*sin(ftmp));
		div[i].y=(U16)(CENTER_Y-RADIUS*cos(ftmp));
		ftmp+=2*PI/60;
	}
	for (i=0;i<60;i++)
	{
		draw_pixel(div[i].x,div[i].y,1);
                 
		if(!(i%5))
		{	draw_pixel(div[i].x-1,div[i].y,1);
	 		draw_pixel(div[i].x+1,div[i].y,1);
	 		draw_pixel(div[i].x,div[i].y-1,GUI_BLACK);
	 		draw_pixel(div[i].x,div[i].y+1,GUI_BLACK);      
		}
	
   	}
}


static void draw_pins(int hour,int minute,int second,U8 clr)
{
	PIXEL pxtmp={0,0};	 
        
	//draw second pin
        pxtmp.x=(CENTER_X+(div[second].x-CENTER_X)*S_PIN_LEN);
        pxtmp.y=(CENTER_Y+(div[second].y-CENTER_Y)*S_PIN_LEN); 
	       
	draw_own_line(CENTER_X,CENTER_Y,pxtmp.x,pxtmp.y,clr,1);
        //draw minute pin
     	pxtmp.x=(CENTER_X+(div[minute].x-CENTER_X)*M_PIN_LEN);
        pxtmp.y=(CENTER_Y+(div[minute].y-CENTER_Y)*M_PIN_LEN);
	draw_own_line(CENTER_X,CENTER_Y,pxtmp.x,pxtmp.y,clr,2);

	//draw hour pin
 	pxtmp.x=(CENTER_X+(div[hour*5+minute/12].x-CENTER_X)*H_PIN_LEN);
        pxtmp.y=(CENTER_Y+(div[hour*5+minute/12].y-CENTER_Y)*H_PIN_LEN);
	draw_own_line(CENTER_X,CENTER_Y,pxtmp.x,pxtmp.y,clr,3);

}

static void draw_own_line(U16 x1,U16 y1,U16 x2,U16 y2, U8 clr,U8 width)
{
 	U8 w,a,b,c,d;
 	int i;

 	w=width/2;
		
	if(x2>x1){
		a=x1+1; b=y1-w; c=x2; d=y2;
		for(i=0;i<width;i++)
		{
			draw_line(a,b++,c,d++,clr); 
		}
	}
	if(x2<x1){
		a=x1-1; b=y1-w; c=x2; d=y2;	
 		for(i=0;i<width;i++)
		{
			draw_line(a,b++,c,d++,clr); 
		}
	}
	if(x2==x1){
		a=x1-w; b=y1; c=x2; d=y2;
		for(i=0;i<width;i++)
		{
			draw_line(a++,b,c,d++,clr);
		} 
	}
}

static void get_time(void)
{
 	time_t td;
 	struct tm *now;
 	struct tm *old;


 	time(&td);

	if(td!=oldtime)
	{	
		old=gmtime(&oldtime);
       		draw_pins(old->tm_hour%12,old->tm_min,old->tm_sec,0);
			 
		/*clear the old pins*/
		now=gmtime(&td);
 		draw_pins(now->tm_hour%12,now->tm_min,now->tm_sec,1);

  		/* draw the new pins*/
		oldtime=td;


		//gettimeofday(&tv,0);
		//printf("tv->sec=%d,tv->usec=%d\n",tv.tv_sec,tv.tv_usec);

 	}

}

static void wait_loop(void)
{
	SCROLLBAR *scrbar; 
	U8 Flag=1;
	GUI_MSG msg;
	short idx;
	short number=0;
	char s[32];
	TEXTBOX *tb;
	short contrast=100;
	
	while (Flag) {
		//get_time();
		
		GetMessage(frmClock,&msg);
		switch (msg.event) {
			case EVENT_CLICK:
				switch (msg.id) {
					case MENUITEM_EXIT:	//Close dialog and go out
						Flag = 0;
						CloseForm(frmClock);
    	    break;
					case BUTTON_SPIN:
						//xor_draw_line(0,0,100,200);
						idx = GetIndexFromId(frmClock,msg.id);
						number += msg.value;
						number = number > 0?number:0;
							SetSpinButtonText(&frmClock[idx],itoa(number));

							// scroll the text
							idx = GetIndexFromId(frmClock,50);
							tb = frmClock[idx].text;
							//tb->start_line += msg.value;
							SetTextBoxStartLine(&frmClock[idx],number);
						
							SetTextBoxText(&frmClock[idx],tb->string);
							strcpy(s,"");
							ShowSoftkey(s,20);
					break;
					case IDD_TEST:
						//SendKeyToForm(frmClock,'W');
						//idx = GetIndexFromId(frmClock,300);
						//idx = RefreshMultiLineString(&frmClock[idx],1);
						//printf("lines:%d\n",idx);
						//TestForm();
						gui_about("I am a test value ","1.0.01");
					break;
					case IDD_SCROLLBAR:
						
					break;
					case IDD_ADDITEM:
						scr.max++;
						idx = GetIndexFromId(frmClock,IDD_SCROLLBAR);
						RefreshComponent(idx,frmClock);
					break;
					default:
						DefaultMessageRoutine(frmClock,&msg);

				} // end of EVENT_CLICK
			break;
			default:
				DefaultMessageRoutine(frmClock,&msg);
		}	
	}  /**** end of message loop *****/
}
  
  
